import greenfoot.*;  
import java.util.*;

public class SchiessGegner extends Gegner
{
    private int zahl = 0;                                                                                   //Variable für den Schuss Cooldown
    private GreenfootImage rechts = new GreenfootImage("Bienerechts.png");                                  //Variable für das Bild, wenn das Objekt nach rechts zeigt
    private GreenfootImage links = new GreenfootImage("BieneLinks.png");                                    //Variable für das Bild, wenn das Objekt nach links zeigt
    private boolean richtung = false;                                                                       //Variable für die Richtung, in welche sich das Objekt bewegt
    private List<Spieler> nahe;                                                                             //Liste für den nächsten Spieler
    private boolean vorhanden = true;                                                                       //Variable um Fehlermeldungen zu verhindern
    public SchiessGegner()
    {
        setImage(links);                                                                                    //Setzt das Bild standartmässig in Linksrichtung

    }
    public void act() 
    {
        schiessen();                                                                                        //Funktion für das Schiessen von Projektilen
        bewegen();                                                                                          //Funktion für die Bewegung
        toeten(getImage().getWidth()/2 + MyWorld.spieler1.getImage().getWidth()/2);                         //Tötet alle Spieler in einem Radies (in "Gegner" definiert)
        loschen();                                                                                          //Funktion um sich selbst zu löschen
        

    }
    
    public void schiessen(){

        if(zahl >= 100)                                                                                     //Prüft ob Cooldown abgelaufen ist (grössergleich um eventuelle Bugs zu verhindern)
        {
                Projektil[] projektileRechts = {new Projektil(4,true,Spieler.class,null)};                  //Array für das Projektil nach rechts (Array, falls man mehrere Projektile in einem Durchlauf schiessen wollte
                Projektil[] projektileLinks = {new Projektil(4,false,Spieler.class,null)};                  //Array für das Projektil nach Links (Array, falls man mehrere Projektile in einem Durchlauf schiessen wollte
            if(richtung)                                                                                    //Prüft in welche Richtung das Objekt zeigt, bzw. schiessen soll
                getWorld().addObject(projektileRechts[0],getX()+getImage().getWidth()/2,getY());            //schiesst nach Rechts
            else
                getWorld().addObject(projektileLinks[0],getX()-getImage().getWidth()/2,getY());             //schiesst nach Links
            
            zahl = 0;                                                                                       //Cooldown wird zurück gesetzt
        }
        
        zahl++;                                                                                             //Cooldown wird jeden Tick reduziert
    }
    
    public void bewegen()
    {
        if(MyWorld.spieleranzahl == 2)
        {if(MyWorld.spieler1.getX()>getX() || MyWorld.spieler2.getX()>getX())                                //ändert die Richtung, wenn ein Spieler vor dem Objekt steht
            {setImage(rechts); richtung = true;}}
        else
         {if(MyWorld.spieler1.getX()>getX())                                //ändert die Richtung, wenn ein Spieler vor dem Objekt steht
            {setImage(rechts); richtung = true;}}
        for(int i = 0 ; true; i++){                                                                         //for schlaufe, welche den nächsten Spieler sucht
            nahe = getObjectsInRange(i, Spieler.class);
            if(!nahe.isEmpty())                                                                             //wenn nächster Spieler gefunden wurde, wird die Schlaufe gebrochen
                break;}
        int zielpos = nahe.get(0).getY();                                                                   //Variable für die Zielposition (Y Position des nächsten Spielers
        
        setLocation(getX(),getY() + (zielpos<getY() ? -1 : (getObjectsAtOffset(0,getImage().getHeight()/2+5,Dreck.class).isEmpty()) ? 1 : 0));  //bewegt sich um 1 pixel näher an die Zielposition (wenn sie bereits gleich ist, bewegt sich das Objekt nicht
        
    }
    
    public void loschen()
    {
        if(getWorld() != null && !getIntersectingObjects(SchiessGegner.class).isEmpty())                                          //löscht sich selbst, wenn es auf einen anderen Schiessgegner trifft
            {getWorld().removeObject(this);vorhanden = false;}
        if(getX()<-50 && vorhanden)                                                                         //löscht sich selbst, wenn es zu weit ins Offset gerät
            getWorld().removeObject(this);
    }
}
