import greenfoot.*;  

public class Schlaggegenstand extends Gegenstand
{
    
    private int maxMunition;                            //Variable für die Munition, die man bekommt, wenn man das Objekt aufnimmt
    
    public Schlaggegenstand(int maxMunition){
    
        this.maxMunition = maxMunition;                 //Variable vom Konstruktor auf die Klasse übertragen
    
    }
    
    public void act() {
        
        if(!getIntersectingObjects(Spieler.class).isEmpty())                //es wird abgeprüft, ob ein Spieler genug nahe ist, um das Objekt aufzunehmen
            {
                aufnehmen(getIntersectingObjects(Spieler.class).get(0));    //Funktion um die Munition dem Spieler hinzuzufügen
            }
        super.act();                                                        //act von "Gegenstand" wird ausgeführt
    }
    
    public void aufnehmen(Spieler s){
    
        s.schlagMunition += maxMunition;                //Munition dem Spieler hinzufügen
    
    }
    
}
