import greenfoot.*;

public class BodenGegner extends Gegner
{
    private boolean richtung = false;                                                                                               //Variable für die Richtung, in welche sich das Objekt bewegt
    private int animationszaehler=0;                                                                                                //Zähler für wann das Bild gewechselt werden soll
    private boolean laufanimation=false;                                                                                            //Variable für das Ändern des Bildes
    private boolean selbstLoeschen = true;                                                                                                 //Variable die Gebraucht wird, da sich ein Objekt nicht im Konstruktor selbst löschen kann
    
    public void act() 
    {
        toeten(getImage().getWidth()/2 + MyWorld.spieler1.getImage().getWidth()/2);                                                //tötet alle Spieler in einem Radius (in "Gegener" definiert)
        bewegen();                                                                                                                  //Methode für das Bewegen
        super.act();                                                                                                                //führt den act von "Gegner" aus (somit auch der von "Mensch"
        if(selbstLoeschen)if(!getIntersectingObjects(BodenGegner.class).isEmpty())                                                  //löscht sich selbst, wenn es auf ein anderen Gegner trifft
            getWorld().removeObject(this);
        selbstLoeschen= false;
    }
    
    public void bewegen()
    {
        
        boolean lochRechts = null == getOneObjectAtOffset(getImage().getWidth()/2, getImage().getHeight()/2 + 5, Boden.class);      //Prüft, ob ein Loch rechts ist
        boolean lochLinks= null == getOneObjectAtOffset(-getImage().getWidth()/2, getImage().getHeight()/2 + 5, Boden.class);       //Prüft, ob ein Loch links ist
        
        boolean wandRechts= null != getOneObjectAtOffset(getImage().getWidth()/2 + 5, getImage().getHeight()/2 - 5, Boden.class);   //Prüft, ob eine Wand rechts ist
        boolean wandLinks= null != getOneObjectAtOffset(-getImage().getWidth()/2 - 5, getImage().getHeight()/2 - 5, Boden.class);   //Prüft, ob eine Wand links ist
        
        if(richtung)                                                                                                                //Prüft in welche Richtung sich das Objekt bewegt
        {    
            linksBewegung();                                                                                                        //geht nach Links
            setLocation(getX() + 1, getY());                                                                                        //geht wieder 1 Pixel nach rechts (um Linksbewegung langsamer wie die vom Spieler zu machen)
            pendelnLinks();                                                                                                         //Funktion für dia Laufanimation wenn sich das Objekt nach Rechts bewegt
            if(lochLinks)                                                                                                           //ändert die Richtung, wenn es ein Loch hat
                richtung=false;
                
            if(wandLinks)                                                                                                           //ändert die Richtung, wenn es eine Wand hat
                richtung=false;    
        }
        else
        {
            rechtsBewegung();                                                                                                       //geht nach Rechts
            setLocation(getX() - 1, getY());                                                                                        //geht wieder 1 Pixel nach Links (um Rechtsbewegung langsamer wie die vom Spieler zu machen)
            pendelnRechts();                                                                                                        //Funktion für dia Laufanimation wenn sich das Objekt nach Rechts bewegt
            if(lochRechts)                                                                                                          //ändert die Richtung, wenn es ein Loch hat
                richtung=true;
            
            if(wandRechts)                                                                                                          //ändert die Richtung, wenn es eine Wand hat
                richtung=true;      
        }
        if(getOneObjectAtOffset(0, getImage().getHeight()/2 + 5, Boden.class) == null)                                              //setzt die Position um 100 Pixel nach unten, wenn das Objekt nicht auf dem Boden steht (um das generieren einfacher zu machen)
            setLocation(getX(),getY()+100);
        }
        
        
        public void pendelnLinks(){                                                                                                 
        if(animationszaehler >= 5)                                                                                                  
        {
            laufanimation = !laufanimation;                                                                                         //wecheselt den Wert von Laufanimation
            animationszaehler = 0;                                                                                                  //Animationszähler wird wieder 0 gesetzt (wird gebraucht, da sinst der Bildwechsel viel zu schnell ist
        }
        
        if(laufanimation)                                                                                                           //Funktion um die Bilder abwechselnd zu setzen
                setImage("Fuchslinks1.png");
        else
                setImage("Fuchslinks2.png");
        
        animationszaehler ++;                                                                                                       //Animationszähler jeden tick um 1 erhöhen
    }
    
    public void pendelnRechts()                                                                                                     //genau gleich aufgebaut wie pendelnLinks()
    {
        if(animationszaehler >= 5)
        {
            laufanimation = !laufanimation;
            animationszaehler = 0;
        }
        if(laufanimation)
             setImage("Fuchsrechts1.png");
        else
             setImage("Fuchsrechts2.png");
        
        animationszaehler ++;
    }
    
}
