import greenfoot.*;  

public class Munitionsanzeige extends Actor implements Unbeweglich{
    
    private Symbol symbol1;                         //Schwert Anzeige
    private Symbol symbol2;                         //Kugel Anzeige
    private int verschiebung;                       //für die Positionierung der symbole nötig
    private GreenfootImage text;                    //für die Positionierung der symbole nötig
    private int welt;
    
    public Munitionsanzeige(){
        this.welt = welt;
        textAktualisieren();
        
    }
    
    //Werte werden aktualisiert
    public void textAktualisieren(){
        if(MyWorld.spieleranzahl == 2){
        String s1 = String.valueOf(MyWorld.spieler1.schlagMunition);
        String s2 = String.valueOf(MyWorld.spieler1.munition);
        String s3 = String.valueOf(MyWorld.spieler2.schlagMunition);
        String s4 = String.valueOf(MyWorld.spieler2.munition);
    
        //alle Zahlen müssen die gleiche Länge haben, um komische verschiebungen zu verhindern
        while(s1.length() < s3.length())
            s1 = "_" + s1;
        
        while(s3.length() < s1.length())
            s3 = "_" + s3;
        
        while(s2.length() < s4.length())
            s2 = "_" + s2;
        
        while(s4.length() < s2.length())
            s4 = "_" + s4;
            
            verschiebung = s2.length();
            
            //Spezielle Anzeige für den unendlich munitionscheat
        if(MyWorld.cheats.muni){
        
            s1 = s2 = s3 = s4 = "∞";
            verschiebung = 2;
        
        }
        //bild erzeugen
        Color durchsichtig = new Color(0,0,0,0);
        String spieler1 = "Spieler 1: " + s1 + "        " + s2;
        String spieler2 = "Spieler 2: " + s3 + "        " + s4;
        GreenfootImage bild = new GreenfootImage(spieler1 + "\n" + spieler2, 18, Color.WHITE, durchsichtig);
        this.text = bild;
        
        setImage(bild);
    }
        else{

        String s1 = String.valueOf(MyWorld.spieler1.schlagMunition);
        String s2 = String.valueOf(MyWorld.spieler1.munition);
    
        //alle Zahlen müssen die gleiche Länge haben, um komische verschiebungen zu verhindern

            verschiebung = s2.length() - 1;
            
            //Spezielle Anzeige für den unendlich munitionscheat
        if(MyWorld.cheats.muni){
        
            s1 = s2 = "∞";
            verschiebung = 1;
        
        }
        //bild erzeugen
        Color durchsichtig = new Color(0,0,0,0);
        String spieler1 = "Spieler 1: " + s1 + "    " + s2;
        GreenfootImage bild = new GreenfootImage(spieler1, 18, Color.WHITE, durchsichtig);
        this.text = bild;
        
        setImage(bild);  
        }
    
    }
    
    //Symbole für Munition erstellen
    public void erstelleSymbole(){
        
        int symbolGroesse = MyWorld.spieleranzahl * 15;
        //Schwertsymbol erzeugen
        GreenfootImage bild = new GreenfootImage("Schwert.png");
        bild.scale(symbolGroesse, symbolGroesse);
        symbol1 = new Symbol(bild);
        
        //Kugelsymbol erzeugen
        bild = new GreenfootImage("Projektilrechts.png");
        bild.scale(symbolGroesse, symbolGroesse);
        symbol2 = new Symbol(bild);
        
        //In der Welt positionieren der beiden Symbole
        int breite = text.getWidth();        
        getWorld().addObject(symbol1, getX() + (breite / 2) - (verschiebung * 8) - 15, getY());
        getWorld().addObject(symbol2, getX() + (breite / 2) + 12 - (MyWorld.spieleranzahl == 1 ? 4 : 0), getY());
    
    }
    
    public void act(){

        textAktualisieren();

        //nicht mehr im Vordergrund, wenn der Endbildschirm gezeigt wird
        if(!MyWorld.spielLaeuft)
            return;

        //Symbole zuerst aus der Welt entfernen und direkt darauf wieder hinzufügen und positionieren
        getWorld().removeObject(symbol1);
        getWorld().removeObject(symbol2);

        int breite = text.getWidth();
        getWorld().addObject(symbol1, getX() + (breite / 2) - (verschiebung * 8) - 15, getY());
        getWorld().addObject(symbol2, getX() + (breite / 2) + 12 - (MyWorld.spieleranzahl == 1 ? 4 : 0), getY());

    }   
}
