import greenfoot.*;
import java.util.*;

public class MyWorld extends Scroller
{
    
    private int gegnerZahl;                                                     //Variable für wie viele Gegner generiert werden sollen
    private Random zufall = new Random();                                       //Zufallsvariable für später
    public static double schwerkraft ;                                          //Schwerkraft für "Menschen" objekte
    public static Spieler spieler1;                                             //Ŝpieler 1 wird initialisiert
    public static Spieler spieler2;                                             //Ŝpieler 2 wird initialisiert
    public static Cheats cheats;                                                //Cheats werden initialisiert
    public Munitionsanzeige munitionsanzeige;                                           //Munitionsanzeige für beide Spieler wird initialisiert
    public static int punkte1;                                                  //Punkte für den Spieler 1 werden initialisiert
    public static int punkte2;                                                  //Punkte für den Spieler 2 werden initialisiert
    protected PunkteStandAnzeige punkteStand1;                                  //Punktestandanzeige für den Spieler 1 wird initialisiert
    protected PunkteStandAnzeige punkteStand2;                                  //Punktestandanzeige für den Spieler 2 wird initialisiert
    public static boolean spielLaeuft = true;                                  //Variable, ob das Spiel beendet ist
    public static int spieleranzahl;                                            //Variable für die Spieleranzahl
    
    public MyWorld(double schwerkraft, int spieleranzahl){    

        super(BREITE, HOEHE, 1,false);                                          //Konstruktor für "Scroller"
        
        punkte1 = 0; punkte2 = 0;                                               //Punkte der Spieler werden 0 gesetzt
        
        this.schwerkraft = schwerkraft;                                         //Schwerkraft wird vom Konstruktor auf "MyWorld" übernommen (kompliziert gemacht, falls man noch eine Unterklasse bräuchte (z.B. für verschiedene Levels
        this.spieleranzahl = spieleranzahl;
        erstelleSpieler();                                                      //Spieler werden generiert
        weltGenerieren();                                                       //welt für Startbildschirm und zweiter Bildschirm wird generiert
        punktestand();                                                          //Punktestand für den Startbildschirm wird generiert
        erstelleCheatActor();                                                   //Cheat Actor wird Generiert
        erstelleMunitionsanzeige();
        spielLaeuft = true;
    }

    public void act(){
        if(spielLaeuft){
        super.act();                                                            //muss eingefügt werden, damit welt gescrollt wird und der Zähler gezählt wird
        neueGegner();                                                           //wenn ein Bildschirm im offset liegt, wird ein neuer generiert
        weltGenerieren();                                                       //wenn ein Bildschirm im offset liegt, wird ein neuer generiert
        punktestand();                                                          //Punktestand wird jeden Tick updated
        cheats();                                                               //Actor im Vordergrund halten
        munitionsanzeige();                                                      //Actor im Vordergrund halten
        spielerInVordergrund();}
    }
    
    public void erstelleSpieler(){                                              

        spieler1 = new Spieler("w", "s", "a", "d", "shift", "space");                           //Spieler wird initialisiert
        addObject(spieler1,BREITE/2,HOEHE/2-50);                                                //Spieler wird generiert
        spieler1.steuerung();                                                                   //Steuerung des Spielers wird ausgeführt, da darin eine Methode ist, die das Bild setzt
        
        if(spieleranzahl == 2){                                                                 //prüfen ob Mehrspieler
        spieler2 = new Spieler("up", "down", "left", "right", "1", "0");                        //Spieler wird initialisiert
        addObject(spieler2,BREITE/2-75,HOEHE/2-50);                                             //Spieler wird generiert
        spieler2.steuerung();}                                                                  //Steuerung des Spielers wird ausgeführt, da darin eine Methode ist, die das Bild setzt

    }
    
    //Cheat Actor erstellen
    public void erstelleCheatActor(){
    
        cheats = new Cheats();                                                                  //Cheats werden initialisiert
        addObject(cheats, 595 - (cheats.getImage().getWidth() / 2), 390);
    
    }
    
    //Munitionsanzeige Actor erstellen
    public void erstelleMunitionsanzeige(){
    
        munitionsanzeige = new Munitionsanzeige();                                              //Munitionsanzeige werden initialisiert
        addObject(munitionsanzeige, 5 + (munitionsanzeige.getImage().getWidth() / 2), 380);
        munitionsanzeige.erstelleSymbole();                                                     //kann erst ausgeführt werden, wenn sich der Actor in der Welt befindet
    
    }
    
    //Cheat Actor in Vordergrund halten
    public void cheats(){

        removeObject(cheats);
        addObject(cheats, 595 - (cheats.getImage().getWidth() / 2), 390);
    
    }
    
    //Munitionsanzeige Actor in Vordergrund halten
    public void munitionsanzeige(){

        removeObject(munitionsanzeige);
        addObject(munitionsanzeige, 5 + (munitionsanzeige.getImage().getWidth() / 2), 380);
    
    }
    
    public void weltGenerieren(){
        int lochpos;                                                                            //lochpos ist selbsterklärend die Variable für die Position des Lochs
        int faktor = 1;                                                                         //Faktor wird gebraucht, wenn man 2 Bildschirme generiert, dass nie 2 Objekte mit gleichen namen generiert werden
        int abschnittHöhe;                                                                      //Variable für die Höhe des Bodens
        int hoehe;                                                                              //Variable für die Höhe, in welcher die Objekte generiert werden
        if(zaehler % 600 == 0)                                                                  //damit nur ein neuer Bildschirm generiert ist, wenn der vorherige nicht mehr im offset liegt
        {
            if(zaehler % 1200 == 0)                                                             //damit nicht 2 Objekte mit gleichem Namen generiert werden können 
                faktor = 2;
                
            Dreck[] drecke = new Dreck[400];                                                    //Array in welchem alle "Dreck objeckte generiert werden 
            for(int k = 0; k<drecke.length ; k++)                                               //Array wird gefüllt
            {
                drecke[k] = new Dreck();
            }
        
            for( int i = 0 ; i<6 ; i++)                                                         //für jeden Sechsel des Bildschirrms ( da dreck 100 Pixel breit ist und der Bildschirm 600) wird nächste schlaufe ausgeführt
            {
                abschnittHöhe = zufall.nextInt(2)+1;
                for (int j = 0; j<abschnittHöhe; j++)                                           //Drecke werden hier generiert und zufällig eins oder 2 hoch gesetzt
                    addObject(drecke[j+i*2*faktor],BREITE/6-50+100*i+BREITE,HOEHE/4+250-j*100);
            
            }
            
            if(zaehler>1000)                                                                    //erstes Loch wird erst ab 1000 Ticks generiert 
            {
                lochpos = zufall.nextInt(6);                                                        //Lochposition steht für welchen Sechstel der Welt das Loch generiert wird
                removeObjects(getObjectsAt(BREITE + BREITE/6*lochpos+50, HOEHE-50, Boden.class));   //dreck wird entfernt, um ein Loch zu erzeugen
                removeObjects(getObjectsAt(BREITE + BREITE/6*lochpos+50, HOEHE-150, Boden.class));
            }
            
            if(zaehler>2000)                                                                    //zweites Loch wird erst ab 2000 Ticks generiert
            {
                lochpos = zufall.nextInt(6);                                                        //Lochposition steht für welchen Sechstel der Welt das Loch generiert wird
                removeObjects(getObjectsAt(BREITE + BREITE/6*lochpos+50, HOEHE-50, Boden.class));   //dreck wird entfernt, um ein Loch zu erzeugen
                removeObjects(getObjectsAt(BREITE + BREITE/6*lochpos+50, HOEHE-150, Boden.class));
            }
           
            if(zaehler==0)                                                                      //startfläche wird generiert
            {
                for (int l = 0; l<6; l++)                                                       //drecke werden generiert
                    addObject(drecke[399-l],BREITE/6-50+100*l,HOEHE/4+250);
            }
            
            Pilz[] pilze = new Pilz[100];                                                       //Array für Pilze wird initialisiert
            for(int k = 0; k<pilze.length ; k++)                                                //Array wird gefüllt
            {
                pilze[k] = new Pilz();
            }
        
            for( int i = 0 ; i<6 ; i++)                                                         //in jedem Sechstel wird ein Pilz generiert
            {
                hoehe = zufall.nextInt(3)+1;                                                    //steht für die Hoehe, in welcher sich der Pilz befindet
                if(zufall.nextInt(10)<5)                                                        //Pilze werden gesetzt, mit 50 % warscheinlichkeit
                    addObject(pilze[i*2*faktor],BREITE/6-50+100*i+BREITE,HOEHE-50-hoehe*100);
            
            }
            
            Erdbeere[] erdbeeren = new Erdbeere[100];                                           //Array für Erdbeeren wird initialisiert
            for(int k = 0; k<pilze.length ; k++)                                                //Array wird gefüllt
            {
                erdbeeren[k] = new Erdbeere();
            }
        
            for( int i = 0 ; i<6 ; i++)                                                         //in jedem Sechstel wird eine Erdbeere generiert
            {
                hoehe = zufall.nextInt(3)+1;                                                    //steht für die Hoehe, in welcher sich die Erdbeere befindet
                if(zufall.nextInt(10)<3)                                                        //Erdbeeren werden gesetzt, mit 30 % warscheinlichkeit
                    addObject(erdbeeren[i*2*faktor],BREITE/6-50+100*i+BREITE,HOEHE-50-hoehe*100);
            
            }
            
            NormaleWaffe[] munition = new NormaleWaffe[100];                                    //Array für normale Waffen(Munition) wird initialisiert
            for(int k = 0; k<munition.length ; k++)                                             //Array wird gefüllt
            {
                munition[k] = new NormaleWaffe();
            }
        
            for( int i = 0 ; i<6 ; i++)                                                         //in jedem Sechstel wird eine normale Waffe generiert
            {
                hoehe = zufall.nextInt(3);                                                      //steht für die Hoehe, in welcher sich die normale Waffe befindet
                if(zufall.nextInt(10)<2)                                                        //normale Waffen werden gesetzt, mit 20 % warscheinlichkeit
                    addObject(munition[i*2*faktor],BREITE/6-50+100*i+BREITE,HOEHE-50-hoehe*100);
            
            }
            
            SchlagWaffe[] schwerter = new SchlagWaffe[100];                                     //Array für Schlagwaffen(schlagMunition/Schwerter) wird initialisiert
            for(int k = 0; k<schwerter.length ; k++)                                            //Array wird gefüllt
            {
                schwerter[k] = new SchlagWaffe();
            }
        
            for( int i = 0 ; i<6 ; i++)                                                         //in jedem Sechstel wird eine Schlagwaffe generiert
            {
                hoehe = zufall.nextInt(2);                                                      //steht für die Hoehe, in welcher sich die Schlagwaffe befindet
                if(zufall.nextInt(10)<1)                                                        //Schlagwaffen werden gesetzt, mit 10 % warscheinlichkeit
                    addObject(schwerter[i*2*faktor],BREITE/6-50+100*i+BREITE,HOEHE-50-hoehe*100);
            
            }
            }
        faktor = 1;                                                                             //Faktor wird zurück gesetzt
        if(zaehler % 10000 == 0 && zaehler != 0 && getObjects(Ziel.class).isEmpty())                                                               //Ziel generieren
            addObject(new Ziel(null) , BREITE + BREITE/2, 100);
        if(punkte1 % 1000 == 0 && punkte1 != 0 && getObjects(Ziel.class).isEmpty() || punkte2 % 1000 == 0 && punkte2 != 0 && getObjects(Ziel.class).isEmpty())          //Ziel generieren
            addObject(new Ziel(null) , BREITE + BREITE/2, 100);
    }
    
    public void neueGegner()
    {

        int gegnerPos;                                                                          //Variable für die Gegnerposition
        int nahANZ = 0;                                                                         //Variable für die Anzahl Nahkampfgegner(Füchse)
        int fernANZ = 0;                                                                        //Variable für die Anzahl Fernkampfgegner
        for(int j = 0; j<zaehler/1000; j++)                                                     //Gegneranzahl wird abhängig vom zähler und vom Zufall generiert
            nahANZ += zufall.nextInt(2);
        for(int j = 0; j<zaehler/1000; j++)                                                     //Gegneranzahl wird abhängig vom zähler und vom Zufall generiert
            nahANZ += zufall.nextInt(2);
        nahANZ+=1;                                                                              //Gegneranzahl wird um 1 erhöht, sodass min. ein Gegner vorhanden sein sollte(so lange sie nicht im Dreck sind)
        fernANZ+=1;                                                                             //Gegneranzahl wird um 1 erhöht, sodass min. ein Gegner vorhanden sein sollte(so lange sie nicht im Dreck sind)
        if(zaehler % 600 == 0)                                                                  //wird nur ausgeführt, wenn vorheriger Bildschirm nicht mehr im offset liegt
        {
            
                
            Gegner[] nah = new Gegner[50];                                                      //Array für Nahkampf Gegner(Füchse) wird initialisiert
            for(int k = 0; k<nah.length ; k++)                                                  //Array wird gefüllt
            {
                nah[k] = new BodenGegner();
            }
        
            for( int i = 0 ; i<nahANZ ; i++)                                                    //Gegner wird an einer zufälligen Position erzeugt
            {
                    addObject(nah[i],BREITE/6-50+100*zufall.nextInt(6)+BREITE,0);
            
            }
            
            
            
            
            
            Gegner[] fern = new Gegner[50];                                                     //Array für Fernkampf Gegner(Bienen) wird initialisiert
            for(int k = 0; k<fern.length ; k++)                                                 //Array wird gefüllt
            {
                fern[k] = new SchiessGegner();
            }
        
            for( int i = 0 ; i<fernANZ ; i++)                                                   //Gegner wird an einer zufälligen Position erzeugt
            {
                    addObject(fern[i],BREITE/6-50+100*zufall.nextInt(6)+BREITE,HOEHE - zufall.nextInt(201)-150);
            
            }
            
            }
        
    }
        
    public void punktestand(){                                                                  //Punktestandanzeige wird updated
        removeObject(punkteStand1);                                                             //alte Punktestandanzeige wird entfernt
        removeObject(punkteStand2);
        
        punkteStand1 = new PunkteStandAnzeige("Punkte Spieler 1: ", punkte1);                   //neue Punktestandanzeige wird erzeugt
        punkteStand2 = new PunkteStandAnzeige("Punkte Spieler 2: ", punkte2);

        addObject(punkteStand1, punkteStand1.getImage().getWidth()/2 + 5, punkteStand1.getImage().getHeight()/2);   //neue Punktestandanzeige wird generiert
        if(MyWorld.spieleranzahl == 2)addObject(punkteStand2, punkteStand2.getImage().getWidth()/2 + 5, punkteStand1.getImage().getHeight() + punkteStand2.getImage().getHeight()/2); //Prüfen ob mehrspieler
        
        
        
    }
    
    public void spielerInVordergrund(){           //actro im vordergrund halten, da er sonst hinter dem Dreck verschwindet

        if(!MyWorld.cheats.keineKollision)
            return;

        int x1 = spieler1.getX();
        int y1 = spieler1.getY();

        removeObject(spieler1);
        addObject(spieler1, x1, y1);

        if(MyWorld.spieleranzahl == 2){                //prüfen ob Mehrspieler
          int x2 = spieler2.getX();     
          int y2 = spieler2.getY();
        
          removeObject(spieler2);
          addObject(spieler2, x2, y2);  
        }
    }
}
